/* ե벻ץΥץȥ ()
 * shige
 * 10/29 2001
 * sndlevel.c
 *
 * $Id: sndlevel.c,v 1.3 2004-01-13 15:40:05+09 shige Exp $
 */
/* gcc -I. -o -DSUPERCEDED sndnormal sndnormal.c sndio.c wavio.c aiffio.c \
 *   fileio.c dist/g771.c dist/ToFromIEEE.c -lm
 */
/* 10/29 2001
 * 1) header ΤˤƤޤȤͤ뤬Ȥꤢϳѿ
 *    ޤȤˤ롣
 */
/* 01/01 2004
 * 2) common.c Ȥä˽ľ
 * 01/06 2004
 * 3) sndlevel ̾ѹ
 * 4) sndvol option ƱͤȤ롣
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

#define Leveldelimit ':'
#define Maxchannel 10

int main(int argc,char *argv[]);
int getarg(int argc,char **argv,double level[],FILE **infile,FILE **outfile);
int setlevel(char *str,double level[]);
void usage(int ret);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile,*tmp=NULL;
    SNDheader snd;
    long int dlen,j,blocks;
    int ret,format,ch,bs,k;
    double level[Maxchannel],maxl[Maxchannel],peek;

    if((ret=getarg(argc,argv,level,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Read SNDheader() error. (%d)\n",format);
	return -format;
    }
    ch=SNDchannels(&snd,format);
    if(ret-1>ch || ch>Maxchannel){
	fprintf(stderr,"Channel number error.. (%d,%d,%d)\n",
		ret-1,ch,Maxchannel);
	return 2;
    }
    put1SNDheader(outfile,&snd,format);
    dlen=SNDdatalen(&snd,format);
    if(infile==stdin){
	tmpnam(NULL);
	if((tmp=tmpfile())==NULL) return 1;
	for(j=1;j<=dlen;j++) fputc(fgetc(infile),tmp);
	fclose(infile);
	if(fseek(tmp,0L,SEEK_SET)<0) return 1;
	infile=tmp;
    }
    if((peek=SNDgetmaxlevelChannel(infile,&snd,format,maxl))<=0.0) return 2;
#ifdef DEBUG1
    {
	for(k=1;k<=ch;k++)
	  fprintf(stderr,"(level,maxlevel)[%d-1]=(%f,%f)\n",
		  k,level[k-1],maxl[k-1]);
    }
#endif
    if(tmp==NULL) fseek(infile,SNDhlen(&snd,format),SEEK_SET);
    else fseek(infile,0L,SEEK_SET);
    /* ǡ */
    blocks=SNDblocks(&snd,format);
    bs=SNDblocksize(&snd,format);
    for(j=1;j<=blocks;j++)
      for(k=1;k<=ch;k++)
	if(level[k-1]<0.0) /* ⤷ʤ */
	  SNDreadput1chdata(infile,outfile,&snd,format);
	else if(level[k-1]==0.0 || maxl[k-1]<=0.0) /* level=0 */ 
	  SNDputnull1ch(outfile,&snd,format);
	else 
	  SNDreadput1chdatavol(infile,outfile,&snd,format,level[k-1]/maxl[k-1]);
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,double level[],FILE **infile,FILE **outfile)
{
    int j,maxchannel=0;

    *outfile=stdout;
    *infile=stdin;

    for(j=1;j<=Maxchannel;j++) level[j-1]=-1.0;
    j=-1;
    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'l':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -12; else argv++; }
		if((j=setlevel(*argv,level))<0) return -13;
		if(j>maxchannel) maxchannel=j;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -1;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -2; else argv++; }
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -3;
		}
		break;
	    case '\0': break;
	    default: return -4;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc>1 ||j<0) return -5;
    else if(argc<1) return maxchannel+1;
    else if(!strcmp(*argv,"-") ||(*infile=fopen(*argv,"r"))!=NULL) 
      return maxchannel+1;
    else{
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -6;
    }
}

int setlevel(char *str,double level[])
{
    int len=strlen(str),j,k,ch;
    char *s;
    double x;

#ifdef DEBUG1
    fprintf(stderr,"DEBUG1: str=[%s]\n",str);
#endif
    if(len<=0) return -1;
    s=str; k=0; ch=0;
    for(j=1;j<=len;j++){
	if(*s==Leveldelimit){
	    if(++k>=2) return -2;
	    *s='\0';
	    if((ch=atoi(str))<=0 || ch>Maxchannel) return -3;
	    level[ch-1]=atof(s+1);
	    return ch;
	}
	s++;
    }
    x=atof(str);
    for(j=1;j<=Maxchannel;j++) level[j-1]=x;
    return 0;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndlevel (-o [outfile]) -l[n1] (-l[n2]...) ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   -l[string]: ̥٥λ",
	"   [infile]: ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] եκ粻̥٥ (sndstat -vl ɽ) ",
	"     ꤷ (0~1) ˤ롣ꤷʤä channel ϲ",
	"     ⤷ʤ",
	" [3] ٥ (-l) ϰʲ̤:",
	"       -l[level]     : ٤Ƥ channel  [level] ˤ",
	"       -l[n]:[level] : [n] channel Τߤ [level] ˤ",
	"     [n]  1 ʾ[٥]  0.0~1.0 ϰϤμ¿",
	" [4] -l ϸλ꤬λ񤭤롣ä㤨",
	"        -l0.9 -l1:0.5 -l1:0.7",
	"     ϡ1 channel  0.7¾ channel  0.9 ˤ롣",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}
